#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(0);
    int t;
    cin>>t;
    while(t--)
    {
        int n,m;
        vector<long long>a;
        vector<long long>b;
        cin>>n>>m;
        for(int i=0;i<n;i++)
        {
            long long in;
            cin>>in;
            a.push_back(in);
        }
        for(int i=0;i<m;i++)
        {
            long long in;
            cin>>in;
            b.push_back(in);
        }
        sort(a.begin(),a.end());
        sort(b.begin(),b.end());
        long long x=LLONG_MAX;
        for(int i=1;i<a.size();i++)
            x=min(x,a[i]-a[i-1]);
        bool flag=true;
        for(int i=1;i<a.size();i++)
        {
            if((a[i]-a[i-1])%x!=0)
            {
                flag=false;
                break;
            }
        }
        for(int i=0;i<b.size();i++)
        {
            if((abs(b[i]-a[0]))%x==0)
            {
                flag=false;
                break;
            }
        }
        if(flag==true)
        {
            cout<<1<<"\n";
        }
        else
        {
            cout<<0<<"\n";
        }
    }

    return 0;
}